--[[    RainPain mod written by BazTheHat

]]

RainPain = {};
RainPain.Rain = 0 -- Rain Level: 0 = None, 1 = light, 2 = moderate, 3 = heavy
RainPain.Ground = 1 -- Ground Dampness: 0 = bone dry, 1 = damp, 2 = soggy, 3 = boggy
RainPain.Damage = 1
if not RainPain.MaxRain then RainPain.MaxRain = RainPain.Rain end -- MaxRain is the maximum amount of rain that had fallen
local Init = 1 -- simple variable to run certain functions once after map has loaded
RainPain.Version = "1.0.0.0"
RainPain.ModName = g_currentModName
RainPain.modDirectory = g_currentModDirectory
quantTools = 0
temperature = 0
COLD = false
frosty = false
warm = true

lastHour = 0
lastDay = 0
local precip, TimeSinceRain, dryEnough, prtBog


function RainPain.prerequisitesPresent(specializations)
    return true
end

source(RainPain.modDirectory .. "AIMessageErrorRain.lua")
source(RainPain.modDirectory .. "audio/NewStepsRegister.lua")



-- Define ALL of the different effects that rain can do here to any particular class of tool


RainPain.Effect = {}

RainPain.Effect["speed"] = {
                        ["cultivator"] = {
                            ["rain"]={1.25, 1.5,2},
                            ["ground"]={1.05, 1.15,1.25}},
                        ["discHarrow"] = {
                            ["rain"]={1.05, 1.25, 1.5},
                            ["ground"]={1.02, 1.04, 1.05}},
                        ["powerHarrow"] = {
                            ["rain"]={1.2,1.3,1.5},
                            ["ground"] = {1, 1.2, 1.2}},
                        ["subSoiler"] = {
                            ["rain"]={1.3, 1.5, 2},
                            ["ground"]={1, 1.2, 1.3}},
                        ["seeder"] = {
                            ["rain"]={1.1,1.3,1.5},
                            ["ground"] = {1, 1.1, 1.1}},
                        ["planter"] = {
                            ["rain"]={1.1,1.3,1.5},
                            ["ground"] = {1, 1.1, 1.1}},
                        ["plow"] = {
                            ["rain"]={1.25,1.5,2},
                            ["ground"] = {0.8, 1.2, 1.25}},
                        ["spader"] = {
                            ["rain"]={1.25,1.5,2},
                            ["ground"] = {0.8, 1.2, 1.25}},
                        ["potatoDigger"] = {
                            ["rain"]={1.05,1.15,1.25},
                            ["ground"] = {1, 1.05, 1.05}},
                        ["mulcher"] = {
                            ["rain"]={1.2,1.3,1.6},
                            ["ground"] = {1.1, 1.15, 1.2}},
                        ["roller"] = {
                            ["rain"]={1.3,1.6,2},
                            ["ground"] = {1.15, 1.2, 1.3}},
                        ["baleLoader"] = {
                            ["rain"]={1.2,1.3,1.5},
                            ["ground"] = {1, 1.1, 1.2}},
                        }
RainPain.Effect["damage"] = {
                        [1] = { name = g_i18n:getText("CULTIVATOR"),
                            ["rain"]= {0.003,0.01,0.015},
                            ["ground"] = {0.001, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {1, 2.5, 5},
                                ["ground"] = {0.2, 0.5, 1}}},
                        [2] = { name = g_i18n:getText("SUBSOILER"),
                            ["rain"]={0.003,0.01,0.0015},
                            ["ground"] = {0.001, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {0.8, 2, 3},
                                ["ground"] = {0.1, 0.4, 0.8}}},
                        [3] = { name = g_i18n:getText("SEEDER"),
                            ["rain"]={0.003,0.008,0.012},
                            ["ground"] = {0, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {0.8, 2, 3},
                                ["ground"] = {0.1, 0.4, 0.8}}},
                        [4] = { name = g_i18n:getText("PLANTER"),
                            ["rain"]={0.003,0.008,0.012},
                            ["ground"] = {0, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {0.8, 2, 3},
                                ["ground"] = {0.1, 0.4, 0.8}}},
                        [5] = {name = g_i18n:getText("WEEDER"),
                            ["rain"]={0.003,0.008,0.012},
                            ["ground"] = {0, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {0.8, 2, 3},
                                ["ground"] = {0.1, 0.4, 0.8}}},
                        [6] = {name = g_i18n:getText("HOE"),
                            ["rain"]={0.003,0.008,0.012},
                            ["ground"] = {0, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {1, 2.5, 5},
                                ["ground"] = {0.2, 0.5, 1}}},
                        [7] = {name = g_i18n:getText("PLOW"),
                            ["rain"]= {0.003,0.01,0.015},
                            ["ground"] = {0.001, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {1, 2.5, 5},
                                ["ground"] = {0.2, 0.5, 1}}},
                        [8] = {name = g_i18n:getText("SPADER"),
                            ["rain"]={0.003,0.008,0.012},
                            ["ground"] = {0, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {0.8, 2, 3},
                                ["ground"] = {0.1, 0.4, 0.8}}},
                        [9] = {name = g_i18n:getText("POTATO_DIGGER"),
                            ["rain"] = {0.0003,0.001,0.003},
                            ["ground"] = {0, 0.0005, 0.0003}},
                        [10] = {name = g_i18n:getText("STONE_PICKER"),
                            ["rain"]={0.005,0.01,0.015},
                            ["ground"] = {0, 0.005, 0.005},
                            ["dirt"] = {
                                ["rain"] = {0.8, 2, 3},
                                ["ground"] = {0.1, 0.4, 0.8}}},
                        [11] = {name = g_i18n:getText("ROLLER"),
                            ["rain"]= {0.003,0.01,0.017},
                            ["ground"] = {0.001, 0.002, 0.003},
                            ["dirt"] = {
                                ["rain"] = {1, 2.5, 5},
                                ["ground"] = {0.2, 0.5, 1}}},
                        [12] = {name = g_i18n:getText("MOWER"),
                            ["rain"]={0.0003,0.001,0.003},
                            ["ground"] = {0, 0.0005, 0.0003},
                            ["dirt"] = {
                                ["rain"] = {1, 2.5, 4},
                                ["ground"] = {0.2, 0.5, 1}}},
                        [13] = {name = g_i18n:getText("TEDDER"),
                            ["rain"]={0.0005,0.001,0.003},
                            ["ground"] = {0, 0.0002, 0.0005}},
                        [14] = {name = g_i18n:getText("BALER"),
                            ["rain"]={0.003,0.008,0.012},
                            ["ground"] = {0, 0.002, 0.003}},
                        [15] = {name = g_i18n:getText("POWER_HARROW"),
                            ["dirt"] = {
                                ["rain"]={0.5,1,2},
                                ["ground"] = {0.2, 0.3, 0.5}}},
                        [16] = {name = g_i18n:getText("DISC_HARROW"),
                            ["dirt"] = {
                                ["rain"]={0.3,1,2},
                                ["ground"] = {0.05, 0.1, 0.3}}},
                        [17] = {name = g_i18n:getText("CAR"),
                            ["dirt"] = {
                                ["rain"] = {0.5, 1, 2},
                                ["ground"] = {0.2, 0.3, 0.5}}},
						[18] = {name = g_i18n:getText("HARVESTER"),
                            ["rain"] = {0.001, 0.005, 0.01},
                            ["ground"] = {0, 0, 0.001}},

                        ["list"] = {"cultivator", "sub soiler", "seeder", "planter", "weeder", "hoe", "plow", "spader", "potato digger", "stone picker", "roller", "mower", "tedder", "baler", "power harrow", "disc harrow", "car", "harvester"}
                    }



local attList = RainPain.Effect.damage.list


function RainPain:TryFieldBox(data, box) -- This function adds info aobut ground state to popup field menu
    local text
    if COLD == true then
        text = g_i18n:getText("COLD_GROUND")
    elseif RainPain.Rain == 0 then -- It's not raining, but how is the ground?
            if RainPain.Ground == 1 then
                text = g_i18n:getText("GROUND_DAMP")
            elseif RainPain.Ground == 2 then
                text = g_i18n:getText("GROUND_SOGGY")
            elseif RainPain.Ground == 3 then
                text = g_i18n:getText("GROUND_BOGGY")
            else
                text = g_i18n:getText("GROUND_DRY")
            end
    else -- it's actually raining right now

        if RainPain.Rain == 1 then
            text = g_i18n:getText("RAIN_LIGHT")
        elseif RainPain.Rain == 2 then
            text = g_i18n:getText("RAIN_MED")
        else
            text = g_i18n:getText("RAIN_HEAVY")
        end
        if RainPain:isFrosty() == true then
            text = g_i18n:getText("GROUND_DRY")
        end
    end
    box:addLine(text) -- write the info on the field
end

-- this command adds the function to display field dampness
PlayerHUDUpdater.fieldAddFarmland = Utils.appendedFunction(PlayerHUDUpdater.fieldAddFarmland, RainPain.TryFieldBox)

function HelpLineManager:loadRainPainHelpLine(superFunc, ...)
    local ret = superFunc(self, ...)
    if ret then
        self:loadFromXML(Utils.getFilename("RainPainHelpPage.xml", RainPain.modDirectory))
        return true
    end
    return false
end

-- Builds help menu items
HelpLineManager.loadMapData = Utils.overwrittenFunction(HelpLineManager.loadMapData, HelpLineManager.loadRainPainHelpLine)

function Combine:getIsThreshingDuringRainPain(earlyWarning)
    local spec = self.spec_combine

    if not spec.allowThreshingDuringRain then
        local rainScale = g_currentMission.environment.weather:getRainFallScale()
        local timeSinceLastRain = g_currentMission.environment.weather:getTimeSinceLastRain()
        if earlyWarning ~= nil and earlyWarning == true then
            if rainScale >= 0.02 and timeSinceLastRain < 20 then
                return true
            end
        else
            if rainScale >= 0.1 and timeSinceLastRain < 20 then
                return true
            end
        end
    end
    if RainPain.Ground > 0 then return true end

    return false
end

-- Makes combines only combine well if ground is perfectly dry
Combine.getIsThreshingDuringRain = Utils.overwrittenFunction(Combine.getIsThreshingDuringRain, Combine.getIsThreshingDuringRainPain)


function RainPain:setVars()
    -- Set initial states for variables here
	
    RainPain.steps = {}
    RainPain.steps.oldSteps = false
    RainPain.steps.loaded = false
	

    RainPain.newDay = false
    RainPain.force = false


    damageCounter = false
    ToolsTimer={}
    ToolsTimer.run = false
    ToolsTimer.count = 0


    quantTools = #g_currentMission.attachables -- find the total number of tools currently out
    local wx = g_currentMission.environment.weather
    frosty = RainPain:isFrosty()
    RainPain:checkTemp()

    lastHour = g_currentMission.environment.currentHour
    if frosty == false then
        lastDay = g_currentMission.environment.currentDay
    else
        lastDay = -1
    end
    precip = wx.cloudUpdater.currentClouds.precipitation
    TimeSinceRain = wx.timeSinceLastRain

    RainPain.days = g_currentMission.environment.daysPerPeriod
    -- NOTE this variable determines how long it takes before the ground is considered dry. 1 game hour x days in month = game hours from boggy to dry
    dryEnough = wx.owner.realHourLength * RainPain.days
    prtBog = -1

    -- This allows tedders to spray without error when raining
    g_motionPathEffectManager.effectsByType.TEDDER[1].fillTypes[3] = 33
    g_motionPathEffectManager.effectsByType.TEDDER[1].effectMaterials[1].fillTypes[2] = 33

end

function RainPain:dryTimeSet()
    if RainPain.days == g_currentMission.environment.daysPerPeriod then
        return
    else
        RainPain.days = g_currentMission.environment.daysPerPeriod
        local wx = g_currentMission.environment.weather
        dryEnough = wx.owner.realHourLength * RainPain.days
    end
end

-- Check for cold conditions
function RainPain:isFrosty()
    if g_currentMission.environment.weather.temperatureUpdater.targetMin <= 5 then
        return true

    else
        return false

    end
end

-- Check if it will get warm at all today
function RainPain:isWarm()
	if g_currentMission.environment.weather.temperatureUpdater.targetMax >= 6 then
        return true

    else
        return false

    end
end

-- If it's a cold day, check if it's reached 5 deg C or less yet
function RainPain:checkCold()
	--print("Is it cold?")
	if lastDay == g_currentMission.environment.currentDay then return end
    frosty = RainPain:isFrosty()
	warm = RainPain:isWarm()
	
    if frosty == false then -- warm all day
       -- print("warm all day")
        lastDay = g_currentMission.environment.currentDay
        RainPain:checkTemp()
    else -- cold at some point
        if lastHour == g_currentMission.environment.currentHour then
            return
        else
            RainPain:checkTemp()
           -- print("Is it cold or warm yet?")

            lastHour = g_currentMission.environment.currentHour
            if COLD == true and warm == false then
                lastDay = g_currentMission.environment.currentDay

            end -- Cold has been set and it'll never warm up today, so stop checking all day
        end
    end
end

-- Check current temp to see if it's cold yet
function RainPain:checkTemp()
    temperature = g_currentMission.environment.weather:getCurrentTemperature()
    if temperature < 5 then
        COLD = true

    else
        if g_currentMission.environment.weather.snowHeight > 0 then
            COLD = true
        else
            COLD = false
        end
    end
end

--Check what the weather is doing
function RainPain:CheckWx()
    -- Has it stayed dry long enough to have dry ground?
    if TimeSinceRain <= dryEnough then
        -- The ground isn't dry, but has the rain state changed?
         if precip ~= g_currentMission.environment.weather.cloudUpdater.currentClouds.precipitation then
                -- rain state has changed, do a rain update
             precip = g_currentMission.environment.weather.cloudUpdater.currentClouds.precipitation
             RainPain:rainUpdate(precip)
         else
            -- Rain state hasn't changed, but it's not dry ground, so check the ground water level
             if precip == 0 then RainPain:dryUpdate(TimeSinceRain)
             end
         end
    else
        -- It's dry, so make sure we know that
        if RainPain.Ground ~= 0 then
            RainPain:dryUpdate(TimeSinceRain)
        end
		if RainPain.Ground == 0 and RainPain.force == true then RainPain:dryUpdate(TimeSinceRain) end
    end
    TimeSinceRain = g_currentMission.environment.weather.timeSinceLastRain
end


-- If the rain state changes, then this decides what that means based on severity.
function RainPain:rainUpdate(rainLevel)
   --local r = ""
    local old = RainPain.Rain
    if rainLevel <=0.1 then
       -- r = "not raining."
        RainPain.Rain = 0

    end
    if rainLevel >0.1 and rainLevel <=0.7 then
       -- r = "lighly raining."
        RainPain.Rain = 1
        RainPain.Ground = 0

    end
    if rainLevel >0.8 and rainLevel <=0.9 then
        --r = "raining moderately."
        RainPain.Rain = 2
        RainPain.Ground = 0

    end
    if rainLevel >0.9 then
       -- r = "raining heavily."
        RainPain.Rain = 3
        RainPain.Ground = 0

    end
    if RainPain.Rain > 0 then prtBog = -1 end
    if RainPain.MaxRain < RainPain.Rain and RainPain.Ground == 0 then RainPain.MaxRain = RainPain.Rain end

    if RainPain.newDay == false then RainPain:newSpeedLimit() end -- only call for new speed limit if awake
    --print("It is currently " .. r)

    if old == 0 and RainPain.Rain ~= 0 then
        -- If it wasn't raining before but it is now, turn any dry grass to wet grass
        DensityMapHeightUtil.changeFillTypeAtArea(1000, -1000, -1000, -1000,  1000, 1000, 35, 33)
    end

    if RainPain.newDay == false then --only check if awake
        if RainPain.Rain > 0 and COLD == false then RainPain.mud = true else RainPain.mud = false end
        -- if raining, make fertilizers not fertilze, otherwise make them fertilize, same with herbicides
        RainPain:changeSprayers()
        RainPain:setSteps()
    end


end

-- If it's stopped raining, how soggy is the ground. tsr = TimeSinceRain
function RainPain:dryUpdate(tsr)
    local numerator = math.ceil(3.3 * RainPain.MaxRain)
    if numerator == math.huge then numerator = 10 end
    local timeTilDry = (dryEnough / 3) * RainPain.MaxRain
    if timeTilDry == 0 then timeTilDry = dryEnough end
    local checkChange = prtBog

    if tsr >0 and tsr <= (timeTilDry / numerator) then
        if (prtBog == 1 or prtBog == -1) then
            --print("Boggy ground")
            prtBog = 2
            RainPain.Ground = RainPain.MaxRain
           -- RainPain:newSpeedLimit()
        end
    end
    if tsr >(timeTilDry / numerator) and tsr <=(timeTilDry / (numerator / 5)) then
        if (prtBog == 2 or prtBog == -1) then
            --print("Soggy ground")
            prtBog = 3
            RainPain.Ground = RainPain.MaxRain - 1
            if RainPain.Ground < 0 then RainPain.Ground = 0 end
            --RainPain:newSpeedLimit()
        end
    end
    if tsr >(timeTilDry / (numerator / 5)) and tsr <= (timeTilDry / (numerator / 8.3)) then
        if prtBog == 3 or prtBog == -1 then
            --print("Damp ground")
            prtBog = 4
            RainPain.Ground = RainPain.MaxRain - 2
            if RainPain.Ground < 0 then RainPain.Ground = 0 end
           -- RainPain:newSpeedLimit()
        end
    end
    if tsr >(timeTilDry / (numerator / 9.8)) then
        if prtBog == 4 or prtBog == -1 then
            --print("Dry ground")
            prtBog = 1
            RainPain.Ground = 0
            RainPain.MaxRain = 0
            --RainPain:newSpeedLimit()
         end
    end

    if RainPain.newDay == false then RainPain:newSpeedLimit() end -- only call new speed limit if awake
    if RainPain.Ground <= 1 or COLD == true then RainPain.mud = false else RainPain.mud = true end -- Mud sets if using muddy footsteps
    if checkChange == prtBog then checkChange = false else checkChange = true end -- has there been a change of state?

    if RainPain.newDay == false and (checkChange == true or RainPain.force == true) then -- only do this if awake and a state has been changed

        RainPain:changeSprayers()
        RainPain:setSteps()
        --if RainPain.force == true then RainPain.force = false end
    end


end

-- This sets liquid fertilizer and herbicide to either off or on depending on rain
function RainPain:changeSprayers()
    if RainPain.Rain > 0 and COLD == false then
        g_sprayTypeManager.fillTypeIndexToSprayType[74].isFertilizer = false
        g_sprayTypeManager.fillTypeIndexToSprayType[81].isHerbicide = false
    else
        g_sprayTypeManager.fillTypeIndexToSprayType[74].isFertilizer = true
        g_sprayTypeManager.fillTypeIndexToSprayType[81].isHerbicide = true
   end
end



-- Main Loop
function RainPain:update(dt)
    if Init == 1 then -- initialising, needs to be done after map has loaded as some vars don't exist otherwise
        RainPain:setVars()
        if precip > 0 then
            RainPain:rainUpdate(precip)
        else
            RainPain:dryUpdate(TimeSinceRain)
        end

        Init = 2
    end
     -- only run the mod if you allow raining
    if g_currentMission.environment.weather.isRainAllowed == true then

        if g_sleepManager.isSleeping == false and RainPain.newDay == true then -- you've just woken up, so check everything once
	
            RainPain.newDay = false
            RainPain.force = true
            RainPain:dryTimeSet()
            RainPain:checkCold()
            RainPain:CheckWx()
            RainPain:newSpeedLimit()
            RainPain.force = false

        end

        if g_sleepManager.isSleeping == false then -- only do the main loop if awake


            -- Check to see if you've loaded the steps yet
            if RainPain.steps.oldSteps == false then RainPain:getOldSteps() end
            if RainPain.steps.loaded == false then RainPain:loadSteps() end -- loads new footstep samples


            RainPain:checkCold() -- is it a cold day?

            -- Check if new vehicles have spawned
            if ToolsTimer.run == true then ToolsTimer.count = ToolsTimer.count + dt end
            if quantTools ~= #g_currentMission.attachables and ToolsTimer.run == false then
                ToolsTimer.run = true
                ToolsTimer.count = 0
            end

            -- If they've spawned, give it 5 seconds before setting new limits
            if ToolsTimer.run == true and ToolsTimer.count > 5000 then
                --print("[TIMER CHECK] Reset timer as timer is " .. ToolsTimer.count)
                ToolsTimer.run = false
                RainPain:newSpeedLimit()
            end

            RainPain:CheckVehicle(dt) -- are you driving a vechicle with damagable implements
            RainPain:CheckWx() -- Check the weather
            RainPain:CheckAI() -- Check if AI Helpers are working in bad weather

        else -- you're sleeping, so only check the weather
            RainPain.newDay = true
            RainPain:CheckWx()

        end
    end
end

-- Some implements have wheels that know what surface they're on, so check if they're on certain surfaces
function RainPain:checkWheels(name)
    local ret = false
    if name == nil then return ret end
    if name == "dirt" or name == "field" or name == "grass" or name == "leaves" then ret = true end
    return ret
end

-- Is it raining, damp ground, or dry?
function RainPain:raining()
    if RainPain.Rain > 0 then
        return "rain", RainPain.Rain
    elseif RainPain.Ground > 0 then
        return "ground", RainPain.Ground
    else
        return "default", 0
    end
end

-- Are you driving a vehicle that has damagable implements?
function RainPain:CheckVehicle(dt)
    local att = g_currentMission.controlledVehicle
    local isAct = false
    if att == nil then return end -- if you're not in a vehicle, stop checking
    if att.lastSpeed > 0.0001 then
        local _ls = true -- yep, you're moving
    else
        return -- well, you're not moving, so it's pointless doing any more checking
    end
    if att ~= nil and (RainPain.Rain ~= 0 or RainPain.Ground ~= 0 or COLD == true) then -- you are in a vehicle, ground isn't dry, does it have implements?
        -- are you in a car?
        if att.typeDesc == "car" then
            RainPain:newDirtMultiplier(0, 17, false) -- make your car dirty
        end

        -- Check if combine is moving and active and on wet ground before complaining
        if att.typeDesc == "harvester" then	
			if att.spec_combine.allowThreshingDuringRain == false and (RainPain.Rain == 0 and RainPain.Ground >0 and COLD == false) then
				if att.spec_combine.fillEnableTime ~= nil and att.spec_combine.threshingDuringRainWarningDisplayed == true then -- this means it's threshing
					g_currentMission:showBlinkingWarning(g_i18n:getText("HARVESTING_WET_GROUND"), 2000)										
				end
			end
		end

        att = att.spec_attacherJoints.attachedImplements

        if att ~= nil then -- you have implements attached, are they active and work an area?
            local c = 0 -- use this to count how many implments have been checked

            for k, v in pairs(att) do
                -- can the attachment work an area?
                local doLoop = false
                local workArea = att[k].object.spec_workArea
                -- is surface of wheels on suitable ground?
                local surface = false
                local surfaceExist = false
                if att[k].object.spec_wheels ~=nil then
                    if att[k].object.spec_wheels.surfaceSounds ~= nil then
                        if att[k].object.spec_wheels.currentSurfaceSound ~= nil then surface = RainPain:checkWheels(att[k].object.spec_wheels.currentSurfaceSound.sampleName) end
                        surfaceExist = true
                    end
                end
                if att[k].object.typeDesc == "mower" then surfaceExist = false end -- This is because mowers have wheels but doesn't know what surface it's on
                -- can the attachhment do work?
                if workArea ~= nil then
                    isAct = att[k].object.spec_workArea.workAreas[1]
                    if isAct.groundReferenceNode ~= nil then isAct = isAct.groundReferenceNode.isActive
                        else
                        isAct = att[k].object.isActive
                    end
                end

                -- So, if it has wheels on the ground and is active OR it doesn't have wheels but it can work an area and is active
                if surfaceExist == true then -- attachment checks wheels on the ground FIRST..
                    if isAct == true and surface == true then doLoop = true end -- if it's also active and on correct surface DO THE DAMAGE CHECK
                else
                    if workArea ~=nil and isAct == true then doLoop = true end -- or, if it's more like a cultivator and active, DO THE DAMAGE CHECK
                end
				
                -- Do main loop if conditions are right
                if doLoop == true then

                    for j, z in pairs(attList) do -- For each attached implement

                        -- Is this implement in the list of affected implements
                        if att[k].object.typeDesc == attList[j] then -- check all attached implements to see if the typeDesc matches wanted ones

                            -- We have a match, but is it a weird one that needs special rules?

                            if att[k].object.typeDesc == "cultivator" then
                            -- But wait! Is it that weird cultivator/subsoiler thingy
                                if att[k].object.spec_cultivator.isSubsoiler == true then j = 2 end
                            elseif att[k].object.typeDesc == "seeder" then
                                local storeItem = g_storeManager:getItemByXMLFilename(att[k].object.configFileName)
                                if storeItem.categoryName == "PLANTERS" then j = 4 end
                            elseif att[k].object.typeDesc == "harvester" then
                                -- We only want potato harvesters here
                                local storeItem = g_storeManager:getItemByXMLFilename(att[k].object.configFileName)
                                if storeItem.categoryName == "POTATOHARVESTING" then j = 9 else break end

                            elseif att[k].object.typeDesc == "tree planter" then j = 4 -- makes tree planters the same as normal planters

                            elseif att[k].object.typeDesc == "weeder" then -- It's a weeder, but is it that weird one?
                                    if att[k].object.spec_powerTakeOffs.inputPowerTakeOffs[1] ~= nil then -- it's the weird one!
                                        if att[k].object.spec_powerTakeOffs.lastIsPowerTakeOffActive == true then j = 3 -- it's a seeder!
                                            else
                                        j = 5 -- treat it as a weeder
                                        end
                                    end
                                    if att[k].object.spec_weeder.isHoeWeeder == true then j = 6 end -- it's a weeder, but is it a hoe?


                            end


                            ---> Add in extra implements that don't normally get damaged but need dirtying

                            -- Found a currently attached implement that fits the description of needing damage
                            RainPain:newDamageAmount(k, att[k].object.spec_wearable.damage, dt, j) -- add new damage amount
                            RainPain:newDirtMultiplier(k, j, true) -- make it dirty
                            break
                        else
                            -- You're not in the damage list, but you might need something else
                            if (att[k].object.typeDesc == "sprayer" or att[k].object.typeName == "fertilizingCultivatorRoller") and att[k].object.spec_sprayer.isWorking == true and RainPain.Rain > 0 then
                                -- sprayer is spraying in the rain!
                                local sprayText = string.lower(g_sprayTypeManager.indexToName[att[k].object.spec_sprayer.fillUnitIndex])
                                g_currentMission:showBlinkingWarning("The " .. sprayText .. " is being washed away by the rain", 2000)
                            end
                        end
                     end
                     c = c + 1
                else
                    c = c + 1 -- current implement isn't active, keep track
                end
            end

            if c >= #att then damageCounter = false end -- if ALL of the implements aren't active then reset the damagecounter
        else
            damageCounter = false
        end
    else
        damageCounter = false
    end
end

-- Add damage amount
function RainPain:newDamageAmount(attachmentIndex, currentDamage, dt, damIndex)
    local damageFromTable = 0
    local displayText = ""

    -- if it's a mower in winter time, don't damage it.
    if g_currentMission.controlledVehicle.spec_attacherJoints.attachedImplements[attachmentIndex].object.typeDesc == "mower" and COLD == true then return end
    if RainPain.Effect.damage[damIndex].rain == nil then return end -- There's no damage info, so ignore it
    if RainPain.Rain > 0 or COLD == true then
        -- Read from Rain Table
        local dm
        if COLD == true then dm = 3 else dm = RainPain.Rain end
        damageFromTable = RainPain.Effect.damage[damIndex].rain[dm]
    elseif RainPain.Ground > 0 then
        -- Read from Ground table
        damageFromTable = RainPain.Effect.damage[damIndex].ground[RainPain.Ground]
    else
        return
    end
-- if it's a weeder, keep messing with the active status
    if RainPain.Effect.damage[damIndex].name == g_i18n:getText("WEEDER") or RainPain.Effect.damage[damIndex].name == g_i18n:getText("HOE") then
        if math.random(3) < RainPain.Rain then
            g_currentMission.controlledVehicle.spec_attacherJoints.attachedImplements[attachmentIndex].object.spec_weeder.isWorking = false
        end
    end
    local thresh = 0.001 -- threshold for receiving warning messages

    local newDamage = currentDamage + ((damageFromTable / 1000) * dt) -- calc new damage amount
    if newDamage > currentDamage then
        if newDamage > 1.0 then newDamage = 1.0 end
        g_currentMission.controlledVehicle.spec_attacherJoints.attachedImplements[attachmentIndex].object.spec_wearable.damage = newDamage -- apply damage
				
        if damageCounter == false and damageFromTable >= thresh then -- haven't sent warning message yet
            if RainPain.Rain ~= 0 and COLD == false then -- warm rain and damaging, get text ready
                displayText = string.gsub(g_i18n:getText("DAMAGE_IMPLEMENT_RAIN"), "%^i", RainPain.Effect.damage[damIndex].name)
            elseif RainPain.Rain == 0 and RainPain.Ground >0 and COLD == false then -- warm and wet ground, get text ready
                displayText = string.gsub(g_i18n:getText("DAMAGE_IMPLEMENT_WET_GROUND"), "%^i", RainPain.Effect.damage[damIndex].name) -- was attList[damIndex]
            elseif COLD == true then -- frozen ground, get text ready
                    displayText = string.gsub(g_i18n:getText("DAMAGE_IMPLEMENT_COLD"), "%^i", attList[damIndex])

            end
            g_currentMission:showBlinkingWarning(displayText, 3000) -- display warning
            damageCounter = true
        end
    end
end

function RainPain:newDirtMultiplier(index, dirt, attachment)
    -- check if item can have extra dirt or not
    local prep, wetVal = RainPain:raining()
    local t = Utils.getNoNil(RainPain.Effect.damage[dirt].dirt, false)
    if t == false then return end -- dirt value doesn't exist, so ignore
    -- so, dirt data exists, but should we use rain or ground data?
    -- Do some quick error checks first
    if prep ~= "rain" and prep ~= "ground" then return end
    if dirt < 1 then return end
    local val = Utils.getNoNil(RainPain.Effect.damage[dirt].dirt[prep][wetVal], 0)
    if val == 0 then return end
    val = val / 400
    -- all is good, and we've grabbed the new firled multiplier data
    if attachment == true then
        g_currentMission.controlledVehicle.spec_attacherJoints.attachedImplements[index].object:addDirtAmount(val, 1)
    else
        g_currentMission.controlledVehicle:addDirtAmount(val, 1)
    end
end

-- Set new speed limits
function RainPain:newSpeedLimit() -- forces all attachables to new speed limit

    if RainPain.force == true then print("[DEBUG] We've just woken up!") end

    local list = g_currentMission.attachables
    if list == nil then return end -- no need to run this if there's absolutely no implements around
    local spdVal
    local prep, value = RainPain:raining()

    -- If it's not raining and the ground is dry, reset speeds to default values for all attachables g_currentMission
    if prep == "default" and COLD == false then
        for k, v in pairs(list) do
            -- set speed limit to default
            g_currentMission.attachables[k].speedLimit = list[k].xmlFile:getValue("vehicle.base.speedLimit#value")

            if list[k].typeDesc == "tedder" then RainPain:tedders(k, prep) end

        end
        quantTools = #list
        -- Reset other features


        return
    end

    -- if it's not wet or soggy ground but it's cold, then use rain speed values
    if prep == "default" and COLD == true then
        prep = "rain"
        value = 3
    end

    -- However, it is either wet ground or raining, so...
   -- Check what tools are around
    for k, v in pairs(list) do
        tool = nil

        if list[k].typeDesc == "cultivator" then
            -- it says cultivator, but is it actually a subsoiler?
            if list[k].spec_cultivator.isSubsoiler == true then
                tool = "subSoiler"

            else
                tool = "cultivator"

            end
        end
        if list[k].typeDesc == "disc harrow" then
            tool = "discHarrow"

        end
        if list[k].typeDesc == "power harrow" then
            tool = "powerHarrow"

        end
        if list[k].typeDesc == "seeder" then
           -- it says seeder, but is it actually a planter?
            local storeItem = g_storeManager:getItemByXMLFilename(list[k].configFileName)
            if storeItem.categoryName == "PLANTERS" then
                tool = "planter"

            else
                tool = "seeder"

            end
        end
        if list[k].typeDesc == "plow" then
            tool = "plow"

        end
        if list[k].typeDesc == "spader" then
            tool = "spader"

        end
        if list[k].typeDesc == "harvester" then
            -- We only want potato harvesters here
            local storeItem = g_storeManager:getItemByXMLFilename(g_currentMission.attachables[k].configFileName)
            if storeItem.categoryName == "POTATOHARVESTING" then
                tool = "potatoDigger"
            else
                tool = nil
            end
        end

        if list[k].typeDesc == "tedder" then RainPain:tedders(k, prep) end


        if list[k].typeDesc == "mulcher" then tool = "mulcher" end
        if list[k].typeDesc == "roller" then
            tool = "roller"

        end

        if list[k].typeDesc == "weeder" then -- It's a weeder, but is it that weird one?
            if list[k].spec_powerTakeOffs.inputPowerTakeOffs[1] ~= nil then -- it's the weird one!
                if list[k].spec_powerTakeOffs.lastIsPowerTakeOffActive == true then
                    tool = "seeder" -- it's a seeder!

                else
                    tool = nil

                end
            else
                tool = nil -- it's just an ordinary weeder, no worries about speed limits

            end
        end

        if list[k].typeDesc == "tree planter" then
            if COLD == false then tool = "planter" else tool = nil end
        end


        if tool ~= nil then -- found a tool that needs new speed limit

            spdVal = g_currentMission.attachables[k].xmlFile:getValue("vehicle.base.speedLimit#value") -- get original speed limit
            if spdVal == math.huge then
                if g_currentMission.controlledVehicle.speedLimit ~= nil then
                    spdVal = g_currentMission.controlledVehicle.speedLimit -- some speed limits are huge, so base it instead on tractor speed limit
                else
                    spdVal = 30 -- can't find tractor speed limit, so just set it at 30
                end
            end
            spdVal = math.floor(spdVal/RainPain.Effect.speed[tool][prep][value])

            g_currentMission.attachables[k].speedLimit = spdVal
        end
    end
    quantTools = #g_currentMission.attachables
end

-- Sometimes, you just need to force a specific speed limit right now
function RainPain:forceSpeedLimitAttached(index, tool, default)
    local prep, value = RainPain:raining()
    if prep == "default" and COLD == true then
        prep = "rain"
        value = 3
    end
    -- If it's not raining and the ground is dry, reset speeds to default values for all attachables g_currentMission


    local spdVal = g_currentMission.controlledVehicle.spec_attacherJoints.attachedImplements[index].object.xmlFile:getValue("vehicle.base.speedLimit#value")
    if default == true then
        g_currentMission.controlledVehicle.spec_attacherJoints.attachedImplements[index].object.speedLimit = spdVal
        return
    else
        if spdVal == math.huge or spdVal == nil then
            if g_currentMission.controlledVehicle.speedLimit ~= nil then
                spdVal = g_currentMission.controlledVehicle.speedLimit
            else
                spdVal = 4
            end
        end
    spdVal = math.floor(spdVal/RainPain.Effect.speed[tool][prep][value])

    g_currentMission.controlledVehicle.spec_attacherJoints.attachedImplements[index].object.speedLimit = spdVal
    end
end

-- This makes tedders useless in rainy conditions
function RainPain:tedders(attachable, rain)
    if RainPain.force == true then print("[TEDDERS] Doing tedders on force wake. Rain = " .. rain) end
    if g_currentMission.attachables[attachable].spec_tedder ~= nil then -- is it actually a tedder?
        local m = Utils.getNoNil(g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[33], false)
        if m == false then -- tedder hasn't been initialised, so do it now
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[33] = {[1] = 3, targetFillTypeIndex = 3}
        end

        -- is it not raining?
        if rain ~= "rain" then
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[33][1] = 3
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[33].targetFillTypeIndex = 3
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[35][1] = 33
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[35][2] = 35
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[35].targetFillTypeIndex = 33

            --[[ Change all tedder effects to spray out normal dried grass
            for p, n in pairs(g_currentMission.attachables[attachable].spec_tedder.effects) do
                for k, v in pairs(g_currentMission.attachables[attachable].spec_tedder.effects[p].effects) do
                    g_currentMission.attachables[attachable].spec_tedder.effects[p].effects[k].fillTypeIndex = 35
                end
            end
]]
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConverters[33].targetFillTypeIndex = 35
            g_currentMission.attachables[attachable].spec_tedder.fillTypeConverters[35].targetFillTypeIndex = 35

        else
            if COLD == false then
            -- it's raining and not freezing/snow
                g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[33][1] = 33
                g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[33].targetFillTypeIndex = 33
                g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[35][1] = 3
                g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[35][2] = 3
                g_currentMission.attachables[attachable].spec_tedder.fillTypeConvertersReverse[35].targetFillTypeIndex = 3

               --[[  Change all tedder effects to spray out normal grass rather than dried grass
                for o, n in pairs(g_currentMission.attachables[attachable].spec_tedder.effects) do
                    for k, v in pairs(g_currentMission.attachables[attachable].spec_tedder.effects[o].effects) do

                        g_currentMission.attachables[attachable].spec_tedder.effects[o].effects[k].fillTypeIndex = 35
                    end
                end
    ]]
                g_currentMission.attachables[attachable].spec_tedder.fillTypeConverters[33].targetFillTypeIndex = 33
                g_currentMission.attachables[attachable].spec_tedder.fillTypeConverters[35].targetFillTypeIndex = 33

            end
        end
    end
end

-- Check if an AI Helper is working with a damagable implement
function RainPain:CheckAI()
    if g_currentMission.aiSystem:getNumActiveJobs() == 0 then return end -- no jobs running so ignore rest of function
    local stop = false
    if COLD == true or RainPain.Rain > 0 or RainPain.Ground > 0 then
        -- It's either cold or rainy or wet ground, so check if there's any AI helpers

        if RainPain:checkHelper() == false then return end -- Checks to see if at least 1 helper is doing fieldwork, if not then stop function
        local ai = g_currentMission.aiSystem.activeJobs

        -- So, at least 1 helper is doing fieldwork, but are they using a damagable attachment
        for k, v in pairs(ai) do -- check each helper
            if ai[k].currentTaskIndex == 2 then -- it's doing fieldwork
                if ai[k].fieldWorkTask.isRunning == true then -- and it's active
                    local test = ai[k].fieldWorkTask.vehicle.spec_attacherJoints.attachedImplements
                    if Utils.getNoNil(test[1], false) ~= false then -- helper has attachements connected to vehicle
                        local doIt = false
                        for j, l in pairs(test) do -- check each attachment
                            for s, t in pairs(attList) do -- check each device in the damage list
                                if test[j].object.typeDesc == attList[s] then
                                    doIt = true
                                    if test[j].object.spec_sprayer ~= nil then
                                        if test[j].object.spec_sprayer.fillTypeSources[73] ~= nil then doIt = false end
                                    end

                                    --Found a worker using a damagabe implement, so stop them
                                    if doIt == true then
                                        g_currentMission.aiSystem:stopJobById(ai[k].jobId, AIMessageErrorUnknown.new(AIMessageErrorRain_mt)) -- stops AI
                                        doIt = false
                                    end
                                    stop = true
                                    break
                                end
                            end
                            if stop == true then break end
                        end
                    end
                end
            end
        end
    end
end


-- Are any AI Helpers currently doing field work?
function RainPain:checkHelper()
    local m = g_currentMission.aiSystem.activeJobs
    for k, v in pairs(m) do
        if m[k].currentTaskIndex == 2 then return true end
    end
    return false
end

-- Checks and loads saved Max Rain value
function RainPain.onStartMission()
	RainPain.savegameFilename = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex).."/RainPain.xml"
	if fileExists(RainPain.savegameFilename) then
		local xmlFile = loadXMLFile("RainPain", RainPain.savegameFilename)
		local t = getXMLInt(xmlFile, "RainPain.value#max")
        if t ~= nil then RainPain.MaxRain = t else RainPain.MaxRain = 0 end
	end
end

-- Saves Max Rain value on save
function RainPain.saveToXMLFile(missionInfo)
	local xmlFile = createXMLFile("RainPain", missionInfo.savegameDirectory .. "/RainPain.xml", "RainPain")
	if xmlFile ~= nil and RainPain.MaxRain then
        setXMLInt(xmlFile, "RainPain.value#max", RainPain.MaxRain)
    end
    saveXMLFile(xmlFile)
    delete(xmlFile)
end

-- Forces new save and load functions into place
Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, RainPain.onStartMission)
FSCareerMissionInfo.saveToXMLFile = Utils.appendedFunction(FSCareerMissionInfo.saveToXMLFile, RainPain.saveToXMLFile)


-- Forces FS22 to actually keep listening to this mod
addModEventListener(RainPain);
